Index: papers/FDL2012/ordering_filter_properties.tex
===================================================================
--- papers/FDL2012/ordering_filter_properties.tex	(revision 68)
+++ papers/FDL2012/ordering_filter_properties.tex	(revision 69)
@@ -1,9 +1,9 @@
 We take advantage of the specification of verified components to build more
-accurate abstractions. The key, here, is how to select the part of the
-specification relevent for the proof of the global property. We propose an
-heuristic to order the properties of each component depending on the structure
+accurate abstractions. The key is how to select the part of the
+specification relevant enough to prove the global property. We propose an
+heuristic to order the properties  depending on the structure
 of each component.
 %Before generating an abstract model to verify a global property $\phi$, the verified properties of all the components in the concrete model are ordered according to their pertinency in comparison to a global property $\phi$.
-In order to do so, the variable dependency of the variables present in global property has to be analysed.
+In order to do so, the variable dependency of the variables present in global property has to be analyzed.
 After this point, we refer to the variables present in the global property  as \emph{primary variables}.
 
@@ -14,20 +14,21 @@
 The variables in the model are weighted according to their dependency level
 \emph{vis-Ã -vis} primary variables and the properties will be weighted according to the sum of the weights
-of the variables present in it. We want to select the properties that describe
-behaviors that have an impact on the global one. Hence, the more closer a variable is from the primary
-variable the more its behavior affects the primary variable. A property will
-have higher priority the more of primary or close to primary variables it
+of the variables present in it. We want to select the properties specifying 
+behaviors that may have an impact on the global property. We observed that 
+the more closer a variable is from the primary
+variable the more it affects the primary variable. Hence, a property will
+have higher priority according to the number of primary or close to primary variables it
 contains.
 Moreover, a global property often specifies the behavior at the interface of
-components. Typicaly, a global property will ensure that a message sent is
-always acknoledge or the good target get the message. This kind of behavior
-relates the input-output behaviors of components.
-We have decided to allocate an extra weight for variables which are present at the interface of a component
-whereas variables which do not interfere in the obtention of a primary variable will be weighted 0.
+components. Typically, a global property will ensure that a message sent is
+always acknowledge or the good target get the message. This kind of behavior
+relates the input-output behaviors of components. 
+We have decided to allocate an extra weight for variables which are present at the interface of a component 
+whereas variables which do not interfere with a primary variable will be weighted 0. 
 Here is how we proceed:
 \begin{enumerate}
 \item Build the dependency graph for all primary variables.
 \item Compute the depth of all variables (DFS or BFS)
-algorithm for all dependency graph.
+in all dependency graph.
 Note that a variable may belong to more than one dependency graph, in that case
 we consider the minimum depth.
@@ -39,5 +40,5 @@
 primary variable with extra weight for interface variable and primary variable.
 
-\begin{algorithm}[h]
+\begin{algorithm}[ht]
 \caption{Compute Weight}
 \label{algo:weight}
@@ -130,9 +131,9 @@
 
 
-Each verified properties available pertinency will be evaluated by adding the weights of all the variables in it.
-It is definitely not an exact pertinency calculation of properties but provides a good indicator
+Each verified properties available pertinence will be evaluated by adding the weights of all the variables in it.
+It is definitely not an exact pertinence calculation of properties but provides a good indicator 
 of their possible impact on the global property.
 After this pre-processing phase, we will have a list of properties $L_\phi$
-ordered according to their pertinency in comparison to the global property.
+ordered according to their pertinence in comparison to the global property.
 
 
@@ -141,78 +142,78 @@
 \subsection{Filtering properties}
 The refinement step consists of adding new AKS of properties selected according to
-their pertinency. This refinement respects the points 1 and 2 of definition
+their pertinence. This refinement respects items 1 and 2 of definition
 \ref{def:goodrefinement}. The first item comes form AKS definition.
+<<<<<<< .mine
 Adding a new AKS in the abstraction leads to an abstraction where more behaviors
 are characterized. Hence there is more constrains behavior and more concretize
 states.
 
-\TODO{Cecile}{Mettre definition, property and proof ?????}
-
-Unforutnatly, this refinement does not ensure that the spurious counter-example
+\remark{CÃ©cile}{Mettre definition, property and proof ?????}
+
+Unfortunately, this refinement does not ensure that the spurious counterexample
 is evicted.
 As we would like to ensure the elimination of the counterexample previously found,
-we filter out properties that don't have an impact on the counterexample $\sigma_i$ thus won't eliminate it.
-In order to reach this obective, a AKS of the counterexample $\sigma_i$, $K(\sigma_i)$
-is generated. $K(\sigma_i)$ is a succession of states corresponding to the counterexample path which dissatisfies
-the global property $\Phi$. It is an abstract kripke structure since not all
-variables are concrete.
-Each properties
-All the properties available are then model-checked on $K(\sigma_i)$. If the
-property holds then the property will not discriminate the counter-example.
-Hence this property is not a good candidate for refinement.
-Therefore all properties that are satisfied won't be chosen to be integrated in the next step of refinement. At this stage, we already have a list of potential properties that will definitely eliminate the current counterexample $\sigma_i$ and might converge the abstract model towards a model sufficient to verify the global property $\phi$.
-
-
-\TODO{Revoir la definition et Proof}
-
-The refinement process from $\widehat{M}_i$ to $\widehat{M}_{i+1}$ can be seperated into 2 steps:
-
-\begin{enumerate}
-
-\item {\emph{\underline{Step 1:}} \\
-
-As we would like to ensure the elimination of the counterexample previously found, we filter out properties that don't have an impact on the counterexample $\sigma_i$ thus won't eliminate it. In order to reach this obective, a Kripke Structure of the counterexample $\sigma_i$, $K(\sigma_i)$ is generated. $K(\sigma_i)$ is a succession of states corresponding to the counterexample path which dissatisfies the global property $\phi$.
-
-\bigskip
-
+we filter out properties that don't have an impact on the counterexample $\sigma$ thus won't eliminate it. 
+In order to reach this objective, a Abstract Kripke structure of the counterexample $\sigma$, $K(\sigma)$
+is generated. $K(\sigma)$ is a succession of states corresponding to the counterexample path which dissatisfies 
+the global property $\Phi$ as show in figure \ref{AKSNegCex}. We add a last
+state $s_t$ where all variable are free({\it unknown}). The tree starting from this
+state represents all the possible future of the counterexample.
+
+
+
+
+%\begin{enumerate}
+%
+%\item {\emph{\underline{Step 1:}}} \\
+%
+%As we would like to ensure the elimination of the counterexample previously found, we filter out properties that don't have an impact on the counterexample $\sigma_i$ thus won't eliminate it. In order to reach this obective, a Kripke Structure of the counterexample $\sigma_i$, $K(\sigma_i)$ is generated. $K(\sigma_i)$ is a succession of states corresponding to the counterexample path which dissatisfies the global property $\phi$.
+%
+%\bigskip
+%
 \begin{definition}
-\textbf{\emph{The counterexample $\sigma_i$ Kripke Structure $K(\sigma_i)$ :}} \\
-Let a counterexample of length $n$, $ \sigma_i = \langle s_{\bar{a}i,0}, s_{\bar{a}i,1},\\ s_{\bar{a}i,2}, ... , s_{\bar{a}i,k}, s_{\bar{a}i,k+1}, ... , s_{\bar{a}i,n}\rangle $ with $ \forall k \in [0,n-1]$, we have \\
-$K(\sigma_i) = (AP_{\sigma_i}, S_{\sigma_i}, S_{0\sigma_i}, L_{\sigma_i}, R_{\sigma_i})$ a 5-tuple consisting of :
+Let $\sigma$ be a counter-example of length $n$ in $\widehat{M}_i$ such
+that $ \sigma =  s_{0}\rightarrow  s_{1}\rightarrow \ldots \rightarrow
+s_{n-1}$. The \emph{Kripke structure derived from $\sigma$} is 6-tuple
+$K(\sigma_i) = (AP_{\sigma}, S_{\sigma}, S_{0\sigma}, L_{\sigma},
+R_{\sigma},F_{\sigma})$
+such that:
 
 \begin{itemize}
-\item { $AP_{\sigma_i}$ : a finite set of atomic propositions which corresponds to the variables in the abstract model $\widehat{V}_{i}$ }	
-\item { $S_{\sigma_i} = \{s_{\bar{a}i,0}, s_{\bar{a}i,1}, s_{\bar{a}i,2}, ... , s_{\bar{a}i,k}, s_{\bar{a}i,k+1}, ... , s_{\bar{a}i,n}\}$}
-\item { $S_{0\sigma_i} = \{s_{\bar{a}i,0}\}$}
-\item { $L_{\sigma_i}$ : $S_{\sigma_i} \rightarrow 2^{AP_{\sigma_i}}$ : a labeling function which labels each state with the set of atomic propositions true in that state. }
-\item { $R_{\sigma_i}$ = $ (s_{\bar{a}i,k}, s_{\bar{a}i,k+1})$ }
+\item $AP_{\sigma} = \widehat{AP}_i$ : a finite set of atomic propositions which corresponds to the variables in the abstract model	
+\item $S_{\sigma} = \{s_{i}|s_i\in \sigma\}\cup\{s_T\}$
+\item $S_{0\sigma} = \{s_{0}\}$
+\item $L_{\sigma} = \widehat{L}_i$
+\item $R_{\sigma} =  \{(s_{k}, s_{k+1})|(s_{k}\rightarrow s_{k+1})\in
+\sigma\}\cup\{(s_{n-1},s_T)\}$ 
+\item $F_{\sigma} = \emptyset$ 
 \end{itemize}
 \end{definition}
 
-%\bigskip
-All the properties available are then model-checked on $K(\sigma_i)$.
-
-If:
-\begin{itemize}
-\item {\textbf{$K(\sigma_i) \vDash \varphi  \Rightarrow \varphi $ will not eliminate $\sigma_i$}}
-\item {\textbf{$K(\sigma_i) \nvDash \varphi  \Rightarrow \varphi $ will eliminate $\sigma_i$}}
-\end{itemize}
-
-%\bigskip
-
-
-%\begin{figure}[h!]
-%   \centering
-%%   \includegraphics[width=1.2\textwidth]{K_sigma_i_S_PNG}
-%%     \hspace*{-15mm}
-%     \includegraphics{K_sigma_i_S_PNG}
-%   \caption{\label{AKSNegCex} Kripke Structure of counterexample $\sigma_i$, $K(\sigma_i)$}
-%\end{figure}
-
-%Dans la figure~\ref{ÃÂ©tiquette} page~\pageref{ÃÂ©tiquette}, Ã¢ÂÂŠ
-
-%\bigskip
-
-
+%%\bigskip
+%All the properties available are then model-checked on $K(\sigma_i)$.
+%
+%If:
+%\begin{itemize}
+%\item {\textbf{$K(\sigma_i) \vDash \varphi  \Rightarrow \varphi $ will not eliminate $\sigma_i$}}
+%\item {\textbf{$K(\sigma_i) \nvDash \varphi  \Rightarrow \varphi $ will eliminate $\sigma_i$}}
+%\end{itemize}
+%
+%%\bigskip
+%
+%
+%%\begin{figure}[h!]
+%%   \centering
+%%%   \includegraphics[width=1.2\textwidth]{K_sigma_i_S_PNG}
+%%%     \hspace*{-15mm}
+%%     \includegraphics{K_sigma_i_S_PNG}
+%%   \caption{\label{AKSNegCex} Kripke Structure of counterexample $\sigma_i$, $K(\sigma_i)$}
+%%\end{figure}
+%
+%%Dans la figure~\ref{ÃÂ©tiquette} page~\pageref{ÃÂ©tiquette}, Ã¢ÂÂŠ
+%
+%%\bigskip
+%
+%
 \begin{figure}[h!]
    \centering
@@ -220,37 +221,68 @@
 \begin{tikzpicture}[->,>=stealth',shorten >=1.5pt,auto,node distance=2cm,
                     thick]
-  \tikzstyle{every state}=[fill=none,draw=blue,text=black, minimum size=1.5cm]
-
-  \node[initial,state] (A)                            {$s_{\bar{a}i,0}$};
-  \node[state]           (B) [below of=A]     {$s_{\bar{a}i,1}$};
-
-  \node[state]           (C) [below of=B]        {$s_{\bar{a}i,k}$};
-
-  \node[state]           (D) [below of=C]       {$s_{\bar{a}i,n-1}$};
-  \node[state]           (E) [below of=D]       {$s_{\bar{a}i,n}$};
-
-  \path (A) edge              node {} (B)
-            (B) edge 	   node {} (C)
-            (C) edge             node {} (D)
-            (D) edge             node {} (E);
+  \tikzstyle{every state}=[fill=none,draw=blue,text=black, minimum size=1.1cm]
+
+  \node[initial,state] (A)                    {$s_{0}$};
+  \node[state]         (B) [below of=A]       {$s_{1}$};
+  \node[node distance=1.5cm]	   (C) [below of=B]       {$\ldots$};
+  \node[state,node distance=1.5cm]       (D) [below of=C]     {$s_{n-1}$};
+  \node[state]         (E) [below of=D]     {$s_T$};
+
+  \path (A) edge node {} (B)
+        (B) edge node {} (C)
+        (C) edge node {} (D)
+        (D) edge node {} (E)
+        (E) edge[loop right] node {} (E);
 
 \end{tikzpicture}
 
-   \caption{\label{AKSNegCex} Kripke Structure of counterexample $\sigma_i$, $K(\sigma_i)$}
+   \caption{\label{AKSNegCex} Kripke Structure of counterexample $\sigma$, $K(\sigma)$}
 \end{figure}
 
-
-}
-%\bigskip
-
-\item {\emph{\underline{Step 2:}} \\
-
-The property at the top of the list (not yet selected and excluding the properties which are satisfied by $K(\sigma_i)$) is selected to be integrated in the generation of $\widehat{M}_{i+1}$.
-%\bigskip
-
-}
+All the properties available for refinement are then model-checked on $K(\sigma)$. If the
+property holds then the property will not discriminate the counterexample.
+Hence this property is not a good candidate for refinement.
+Therefore all properties that are satisfied won't be chosen to be integrated in the next step of refinement. At this stage, we already have a list of potential properties that will definitely eliminate the current counterexample $\sigma$ and might converge the abstract model towards a model sufficient to verify the global property $\Phi$.
+
+\begin{property}{Counterexample evicted}
+\begin{enumerate}
+\item If {\textbf{$K(\sigma) \vDash \varphi  \Rightarrow AKS(\varphi) $ will
+not eliminate $\sigma$}}.
+\item If {\textbf{$K(\sigma) \nvDash \varphi  \Rightarrow AKS(\varphi) $ will
+eliminate $\sigma$}}.
 \end{enumerate}
-
-$\widehat{M}_{i+1}$ is model-checked and the refinement process is repeated until the model satisfies the global property or there is no property left to be integrated in next abstraction.
-
-
+\end{property}
+\begin{proof}
+By construction, $AKS(\varphi)$ simulates all model that verify 
+$\varphi$. Thus the tree describes by $K(\sigma)$ exists in $AKS(\varphi)$,
+$\sigma$ is still a possible path in $AKS(\varphi)$.\\
+Conversely $K(\sigma_i)$, where $\varphi$ does not hold, is not simulated by
+$AKS(\varphi)$, thus $\sigma$ is not a possible path in $AKS(\varphi)$
+otherwise $AKS(\varphi)\not\models \varphi$ that is not feasible due to AKS
+definition.
+
+\end{proof}
+
+The property at the top of the list (not yet selected and excluding the properties
+which are satisfied by $K(\sigma)$) is selected to be integrated in the generation of $\widehat{M}_{i+1}$.
+We ensure that our refinement respect the definition \ref{def:goodrefinement}.
+Moreover, the time needed to build an AKS can be neglected and building the
+next abstraction is just a parallel composition with the previous one. Thus the refinement
+ we propose is not time consuming.
+
+
+%
+%}
+%%\bigskip
+%
+%\item {\emph{\underline{Step 2:}} \\
+%
+%The property at the top of the list (not yet selected and excluding the properties which are satisfied by $K(\sigma_i)$) is selected to be integrated in the generation of $\widehat{M}_{i+1}$.
+%%\bigskip
+%
+%}
+%\end{enumerate}
+%
+%$\widehat{M}_{i+1}$ is model-checked and the refinement process is repeated until the model satisfies the global property or there is no property left to be integrated in next abstraction.
+%
+